diff --git a/gnu/packages/crates-io.scm b/gnu/packages/crates-io.scm
index 2950e8b0e3..1d05eab5f7 100644
--- a/gnu/packages/crates-io.scm
+++ b/gnu/packages/crates-io.scm
@@ -38166,41 +38166,50 @@ (define-public rust-juliex-0.3
 concurrency primitives and multiple allocations.")
     (license (list license:expat license:asl2.0))))
 
-(define-public rust-juniper-0.15
+(define-public rust-juniper-0.16
   (package
     (name "rust-juniper")
-    (version "0.15.12")
+    (version "0.16.1")
     (source
      (origin
        (method url-fetch)
        (uri (crate-uri "juniper" version))
        (file-name (string-append name "-" version ".tar.gz"))
        (sha256
-        (base32 "1dg1b5msr8k4kwmam2h0f64z7aamk4799vdh3cg55c881idclpc7"))))
+        (base32 "0b4ql1ys8l3xxfyg8zf1624dmx6ri31b1pzrgb906yhsbcqhccwl"))))
     (build-system cargo-build-system)
     (arguments
      `(#:cargo-inputs
        (("rust-anyhow" ,rust-anyhow-1)
         ("rust-async-trait" ,rust-async-trait-0.1)
+        ("rust-auto-enums" ,rust-auto-enums-0.8)
+        ("rust-bigdecimal" ,rust-bigdecimal-0.4)
         ("rust-bson" ,rust-bson-1)
         ("rust-chrono" ,rust-chrono-0.4)
-        ("rust-chrono-tz" ,rust-chrono-tz-0.5)
+        ("rust-chrono-tz" ,rust-chrono-tz-0.8)
+        ("rust-rust-decimal" ,rust-rust-decimal-1)
         ("rust-fnv" ,rust-fnv-1)
         ("rust-futures" ,rust-futures-0.3)
         ("rust-futures-enum" ,rust-futures-enum-0.1)
-        ("rust-graphql-parser" ,rust-graphql-parser-0.3)
-        ("rust-indexmap" ,rust-indexmap-1)
-        ("rust-juniper-codegen" ,rust-juniper-codegen-0.15)
+        ("rust-graphql-parser" ,rust-graphql-parser-0.4)
+        ("rust-indexmap" ,rust-indexmap-2)
+        ("rust-juniper-codegen" ,rust-juniper-codegen-0.16)
+        ("rust-ryu" ,rust-ryu-1)
         ("rust-serde" ,rust-serde-1)
         ("rust-serde-json" ,rust-serde-json-1)
         ("rust-smartstring" ,rust-smartstring-1)
         ("rust-static-assertions" ,rust-static-assertions-1)
+        ("rust-tap" ,rust-tap-1)
+        ("rust-time" ,rust-time-0.3)
         ("rust-url" ,rust-url-2)
-        ("rust-uuid" ,rust-uuid-0.8))
+        ("rust-uuid" ,rust-uuid-1)
+        ("rust-void" ,rust-void-1))
        #:cargo-development-inputs
        (("rust-bencher" ,rust-bencher-0.1)
-        ("rust-pretty-assertions" ,rust-pretty-assertions-0.7)
+        ("rust-chrono" ,rust-chrono-0.4)
+        ("rust-pretty-assertions" ,rust-pretty-assertions-1)
         ("rust-serde-json" ,rust-serde-json-1)
+        ("rust-serial-test" ,rust-serial-test-3)
         ("rust-tokio" ,rust-tokio-1))))
     (home-page "https://github.com/graphql-rust/juniper")
     (synopsis "GraphQL server library for Rust")
@@ -38216,6 +38225,43 @@ (define-public rust-juniper-0.15
 debugging.")
     (license license:bsd-2)))
 
+(define-public rust-juniper-0.15
+  (package
+    (inherit rust-juniper-0.16)
+    (name "rust-juniper")
+    (version "0.15.12")
+    (source
+     (origin
+       (method url-fetch)
+       (uri (crate-uri "juniper" version))
+       (file-name (string-append name "-" version ".tar.gz"))
+       (sha256
+        (base32 "1dg1b5msr8k4kwmam2h0f64z7aamk4799vdh3cg55c881idclpc7"))))
+    (arguments
+     `(#:cargo-inputs
+       (("rust-anyhow" ,rust-anyhow-1)
+        ("rust-async-trait" ,rust-async-trait-0.1)
+        ("rust-bson" ,rust-bson-1)
+        ("rust-chrono" ,rust-chrono-0.4)
+        ("rust-chrono-tz" ,rust-chrono-tz-0.5)
+        ("rust-fnv" ,rust-fnv-1)
+        ("rust-futures" ,rust-futures-0.3)
+        ("rust-futures-enum" ,rust-futures-enum-0.1)
+        ("rust-graphql-parser" ,rust-graphql-parser-0.3)
+        ("rust-indexmap" ,rust-indexmap-1)
+        ("rust-juniper-codegen" ,rust-juniper-codegen-0.15)
+        ("rust-serde" ,rust-serde-1)
+        ("rust-serde-json" ,rust-serde-json-1)
+        ("rust-smartstring" ,rust-smartstring-1)
+        ("rust-static-assertions" ,rust-static-assertions-1)
+        ("rust-url" ,rust-url-2)
+        ("rust-uuid" ,rust-uuid-0.8))
+       #:cargo-development-inputs
+       (("rust-bencher" ,rust-bencher-0.1)
+        ("rust-pretty-assertions" ,rust-pretty-assertions-0.7)
+        ("rust-serde-json" ,rust-serde-json-1)
+        ("rust-tokio" ,rust-tokio-1))))))
+
 (define-public rust-juniper-0.14
   (package
     (inherit rust-juniper-0.15)